#!/bin/bash

set -ex

BUFRDIR={{ obs_from_wis_incoming_dir | quote }}
WORKDIR={{ obs_from_wis_work_dir | quote }}
DOWNLOAD_AGE={{ obs_from_wis_max_download_age_hours | quote }}
DELETE_AGE={{ obs_from_wis_max_delete_age_days | quote }}
CENTRES={{ obs_from_wis_centres | join(',') | quote }}


PIDFILE="$WORKDIR/pid"
METRICSFILE="$WORKDIR/metrics"


mkdir -p "$BUFRDIR" "$WORKDIR"
if test ! -r "$BUFRDIR/README.txt" ; then
    # create some file such that the download directory is not empty
    echo "BUFR download from JMA" > "$BUFRDIR/README.txt"
fi
find "$BUFRDIR/" -type f -name '*.bufr*' -mtime "+$DELETE_AGE" -exec rm -vf \{\} \;
find "$BUFRDIR/" -empty -type d -delete

if test -s "$PIDFILE" ; then
    if test -r "$METRICSFILE" ; then
        MTIME=`stat -c %Y "$METRICSFILE"`
        RECENT=$(( `date +%s` - 3 * 60 ))
{% if node_exporter_textfile_dir is defined %}
        PROMDIR={{ node_exporter_textfile_dir | quote }}
        PROMFILE="$PROMDIR/devcoop_obs_from_wis.prom"
        cp -f "$METRICSFILE" "$PROMFILE"
{% endif %}
    else
        MTIME=0
        RECENT=1
    fi
    if test "$MTIME" -le "$RECENT" ; then
        # metrics file is old; process seems to be dead / unresponsive; kill it
        PID=`cat $PIDFILE`
        kill -9 "$PID" || true
        rm -f "$PIDFILE"
    fi
fi

if test ! -r "$PIDFILE" ; then
    # start new process
    "$(dirname $0)/fetch_obs" \
        --outdir="$BUFRDIR" \
        --workdir="$WORKDIR" \
        --centres="$CENTRES" \
        --max-age="$DOWNLOAD_AGE" > "$WORKDIR/fetch.log" 2>&1 &
    echo "$!" > "$PIDFILE"
fi
